hdu 5542 The Battle of Chibi(DP+树状数组+离散化)

时间:2022-04-24 19:27:54

The Battle of Chibi

Problem Description
Cao Cao made up a big army and was going to invade the whole South China. Yu Zhou was worried about it. He thought the only way to beat Cao Cao is to have a spy in Cao Cao’s army. But all generals and soldiers of Cao Cao were loyal, it’s impossible to convince any of them to betray Cao Cao.

So there is only one way left for Yu Zhou, send someone to fake surrender Cao Cao. Gai Huang was selected for this important mission. However, Cao Cao was not easy to believe others, so Gai Huang must leak some important information to Cao Cao before surrendering.

Yu Zhou discussed with Gai Huang and worked out N information to be leaked, in happening order. Each of the information was estimated to has ai value in Cao Cao’s opinion.

Actually, if you leak information with strict increasing value could accelerate making Cao Cao believe you. So Gai Huang decided to leak exact M information with strict increasing value in happening order. In other words, Gai Huang will not change the order of the N information and just select M of them. Find out how many ways Gai Huang could do this.

Input
The first line of the input gives the number of test cases, T(1≤100). T test cases follow.

Each test case begins with two numbers N(1≤N≤103) and M(1≤M≤N), indicating the number of information and number of information Gai Huang will select. Then N numbers in a line, the ith number ai(1≤ai≤109) indicates the value in Cao Cao’s opinion of the ith information in happening order.

Output
For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the ways Gai Huang can select the information.

The result is too large, and you need to output the result mod by 1000000007(109+7).

Sample Input
2
3 2
1 2 3
3 2
3 2 1

Sample Output
Case #1: 3
Case #2: 0
Hint

In the first cases, Gai Huang need to leak 2 information out of 3. He could leak any 2 information as all the information value are in increasing order.
In the second cases, Gai Huang has no choice as selecting any 2 information is not in increasing order.

思路:
首先这道题n^3复杂度的很容易想出来,状态转移方程为
dp[i][j]=dp[i][j]+dp[1~(i-1)][j-1]代表到i位置长度为j的方案数
可是写出来直接就TLE了。。。

那我们观察一下,发现在查找所有长度为j-1且尾节点a[p]<a[i]的子序列个数的这个操作是可以优化的,而一般在区间内查找更新的优化很容易就能想到线段树和树状数组。因此树状数组就上场了。

但是还有一点就是有可能会有重复的a[i],还有可能a[i]很大,m很小,如果每次都把所有的长度都更新的话,空间和时间很可能不够用,所以我们需要离散化一下。(具体详见代码)

代码:

#include<stdio.h>
#include<set>
#include<map>
#include<string.h>
using namespace std;

#define maxn 1010
const int mod=1000000007;
int dp[maxn][maxn],a[maxn],c[maxn][maxn];
int n,m,len;
map<int,int>mp;

int lowbit(int x)
{
return x&-x;
}

void updata(int j,int x,int num)
{
while(x<len)
{
c[j][x]=(c[j][x]+num)%mod;
x+=lowbit(x);
}
}

int getsum(int j,int x)
{
int sum=0;
while(x)
{
sum=(c[j][x]+sum)%mod;
x-=lowbit(x);
}
return sum;
}


int solve()
{
for(int i=1; i<=n; ++i)
{
dp[i][1]=1;
updata(1,mp[a[i]],1);
for(int j=2; j<=m; ++j)
{
int num=getsum(j-1,mp[a[i]]-1)%mod;
if(!num)
break;
dp[i][j]=(dp[i][j]+num)%mod;
updata(j,mp[a[i]],num);
}
}
int ans=0;
for(int i=1; i<=n; ++i)
ans=(dp[i][m]+ans)%mod;
return ans;
}

int main()
{
int t,k=0;
scanf("%d",&t);
while(++k<=t)
{
memset(c,0,sizeof(c));
memset(dp,0,sizeof(dp));
mp.clear();
set<int>s;
scanf("%d%d",&n,&m);
for(int i=1; i<=n; ++i)
{
scanf("%d",&a[i]);
s.insert(a[i]);
}
len=1;
for(set<int>::iterator it=s.begin(); it!=s.end(); ++it)
mp[*it]=len++;
printf("Case #%d: %d\n",k,solve());
}
return 0;
}



ps:better,学到了好多,尤其是思路上面的。